var log = require('../lib/logger.js');
var config = require('../config/config');
var nodemailer = require("nodemailer");
var ejs = require('ejs');
var ses = require('nodemailer-ses-transport');

sendEmailThroughTransport = function(transporter, mailOptions) {
    log.info("sendEmailThroughTransport");
    transporter.sendMail(mailOptions, function(error, response) {
        log.info('inside sendMail:');
        if (error) {
            log.info(error);
        } else {
            log.info("Message sent: ");
            log.info(response);
        }
    });
}

//Sends mail to the specified mailId
//params: userName,mailID
module.exports.mailSender = function(userName, mailId, token, roomid, emailData, callBack) {

    log.info("mailsender method recieving parameters:username:" + userName + "mailId:" + mailId + "token:" + token + "roomid:" + roomid + "existingmember" + emailData.existingmember);
    if (!mailId) {
        log.info('Invalid email contact');
    } else {
        var transporter = nodemailer.createTransport(ses({
            accessKeyId: config.s3accessKey,
            secretAccessKey: config.s3secretKey
        }))
        var text;
        if(token != 'token'){
            text = = ejs.render('Chat Token To Login is '+token);
        }
        else {
            text = = ejs.render('Hello, Welcome to Chat!');
        }
        var mailOptions = {
            from: config.adminemail,
            to: mailId,
            subject: "New Chat Invite",
            text: text

        }
        transporter.sendMail(mailOptions);
        // sendEmailThroughTransport(transporter, mailOptions);
        callBack(emailData);
    }
}
