var mongoose = require('../models/mongoose');

var commLog = mongoose.Schema({
    roomId: String,
    from: String,
    type: String,
    userId: String,
    username: String,
    messsage: {},
    timestamp: {
        type: String,
        index: true
    }
});

var chatlog = mongoose.model('commLog', commLog);
exports.chatlog = chatlog;


var auditLog = mongoose.Schema({
    userId: String,
    event: String,
    timestamp: String

});



var alog = mongoose.model('auditLog', auditLog);
exports.alog = alog;


var profiles_schema = mongoose.Schema({
    username: {
        firstname: {
            type: String,
            trim: true
        },
        lastname: {
            type: String,
            trim: true
        }
    },
    email: [{
        value: {
            type: String,
            trim: true
        },
        formattedValue: {
            type: String,
            trim: true
        },
        type: {
            type: String,
            trim: true
        }
    }],
    status: String,
    groups: [String],
    validprofile: Boolean,
    deviceInfo: [{
        uuid: {
            type: String,
            trim: true
        },
        devicetype: {
            type: String,
            trim: true
        },
        devicetoken: {
            type: String,
            trim: true
        },
        token: String,
        tokenValidated: Boolean
    }]
    loginkey: {
        type: String,
        require: true,
        trim: true
    },
    timestamp: {
        type: String,
        trim: true
    },
    userId: String,

});


var profiles = mongoose.model('profiles', profiles_schema);
exports.profiles = profiles;

var chatGroup = mongoose.Schema({
    groupName: String,
    roomId: String,
    attendees: [{
        userid: {
            type: String,
            trim: true
        },
        requestId: {
            type: String,
            trim: true
        },
        jointime: {
            type: String,
            trim: true
        },
        lastremaindertime: {
            type: String,
            trim: true
        },
        initialurl: {
            type: String,
            trim: true
        },
        contact: {
            type: String,
            trim: true
        },
        moc: {
            type: String,
            trim: true
        },
        username: {
            type: String,
            trim: true
        },
        unreadcount: {
            type: Number,
            trim: true
        },
        chatprogress: Boolean,
        accepted: Boolean,
        profile_id: {
            type: mongoose.Schema.Types.Mixed,
            ref: 'profiles'
        }
    }],
    attendeesBackUp: [{
        userid: {
            type: String,
            trim: true
        },
        requestId: {
            type: String,
            trim: true
        },
        jointime: {
            type: String,
            trim: true
        },
        lastremaindertime: {
            type: String,
            trim: true
        },
        initialurl: {
            type: String,
            trim: true
        },
        contact: {
            type: String,
            trim: true
        },
        moc: {
            type: String,
            trim: true
        },
        username: {
            type: String,
            trim: true
        },
        unreadcount: {
            type: Number,
            trim: true
        },
        chatprogress: Boolean,
        accepted: Boolean,
        initialurl: {
            type: String,
            trim: true
        },
        profile_id: {
            type: mongoose.Schema.Types.Mixed,
            ref: 'profiles'
        }
    }],
    admins: [String],
    lastremaindertime: {
        type: String,
        trim: true
    },
    message: String,
    timestamp: {
        type: String,
        index: true
    },
    purpose: {
        type: String,
        index: true
    },
    clienttime: Date,
    requests: [String],
    lastChat: {
        userId: String,
        chatType: String,
        messsage: {},
        timestamp: String
    }
});


var chatGroup = mongoose.model('chatGroup', chatGroup);
exports.chatGroup = chatGroup;

var smsNumbersSchema = mongoose.Schema({
    smsnumber: {
        type: String
    },
    usageCount: {
        type: Number,
        default: 0
    },
    availability: Boolean
});

var smsnumbers = mongoose.model('smsnumbers', smsNumbersSchema);
exports.smsnumbers = smsnumbers;
