var nodemailer = require("nodemailer");
var crypto = require('crypto');
var jadeCompiler = require('./jadeCompiler');
var config = require('../config/config');
var notify = require("push-notify");
var log = require('../lib/logger.js');
var whitelisted = "whitelisted";
var db = require('../models/schema');
var ses = require('nodemailer-ses-transport');
var uid = require('node-uuid');
var twilioInterface = require('twilio');
var BitlyAPI = require("node-bitlyapi");
var stringManipulator = require('string');
var validator = require('validator');
var Promise = require('bluebird');


module.exports.getCurrentTimestamp = function(){
	return new Date().getTime();
};

//Common PushNotification function
module.exports.pushNotify = function(dType,dToken,rId,userid,mcount,inviteThrough,emailData){
	log.info("pushnotification starts:",dType,dToken,rId,userid,mcount,inviteThrough,emailData.invitecode,emailData.moc);
	var res;
	try{
    getUsername(emailData.fromuserid,function(username){
    var production_mode = false;
    log.info("PRODUCTION MODE:"+config.production);
    if(config.production == 'production')
      production_mode = true;
  if (dType === 'iOS'){
      var apn = notify.apn({
                "cert": config.iOSCert,
                "key": config.iOSKey,
               "production": production_mode,
               "passphrase": config.iOSPassword

            });
    if(inviteThrough == 'newmessage')
    {
      var alertToSend;
      var messageToDispaly;
      if(emailData.chattype == "image")
      {
        alertToSend = "Image received";
        messageToDispaly = "Image received";
      }
      else if (emailData.chattype == "video" ){
        alertToSend = "Video received";
        messageToDispaly = "Image received";
      }
      else if (emailData.chattype == "card" ){
        alertToSend = "card received";
        messageToDispaly = "card received";
      }
      else
      {
        alertToSend = emailData.message;
        messageToDispaly = emailData.message;
      }
      var objToSend = new Object();
      objToSend = {'fromuserid': emailData.fromuserid,'members':mcount,'touserid':emailData.touserid,'chattype':emailData.chattype,'message':messageToDispaly,'roomid':emailData.roomid,'roomunread':emailData.roomunread,'allunread':emailData.allunread,'timestamp':emailData.timestamp};
      log.info("*******sending Parameter for ios Push notification*********"+JSON.stringify(objToSend));

      var apnNotifOptions = {
        "token" : dToken,
        "alert" : username + " : "+ alertToSend,
        'fromuserid': emailData.fromuserid,
        'touserid':emailData.touserid,
        'chattype':emailData.chattype,
        'message':messageToDispaly,
        'roomid':emailData.roomid,
        'roomunread':emailData.roomunread,
        'allunread':emailData.allunread,
        'timestamp':emailData.timestamp,
        'members':mcount
      };
      apnNotifOptions.badge = emailData.allunread
    }
    else
    {
      var objToSend = new Object();
      objToSend = {'roomid': rId,'userid':userid,'members':mcount,'invitethrough':inviteThrough,'invitecode':emailData.invitecode,'moc':emailData.moc};
      log.info("*******sending Parameter for ios Push notification*********"+JSON.stringify(objToSend));
      var alertToSend;
      if(inviteThrough == "chat")
      {
          alertToSend = "Chat invite from "+emailData.invitinguser;
      }
      else{
          alertToSend = "Invite";
      }
      var apnNotifOptions = {
                      "token" : dToken,
                      "alert" : username + " : " +alertToSend,
                      "message": alertToSend,
                      "roomid": rId,
                      "userid": userid,
                      "members": mcount,
                      "invitethrough": inviteThrough,
                      "invitecode":emailData.invitecode,
                      "moc":emailData.moc
                  };
      apnNotifOptions.badge = emailData.allunread
    }

    apnNotifOptions.sound = "default"
    apnNotifOptions.payload = objToSend

    apn.send(apnNotifOptions);
    apn.close(function() {
        log.info("Closed apn socket connection");

    });


    apn.on('transmitted', function (notification, device) {
        log.info("Successful Push Notification transmission to APNS for device token: "+dToken);
    });

    apn.on('transmissionError', function (errorCode, notification, device) {
        log.info("Error in Push Notification transmission to APNS for device token: "+dToken+" Error Code: "+errorCode);
    });

    apn.on('error', function (error) {
        log.info("APNError: "+error);

    });


}else{

    log.info('Android implementation ::'+JSON.stringify(emailData));
    // This registration token comes from the client FCM SDKs.
    //var registrationToken = "cyLCAfAI3sk:APA91bGOKcxzbeAalPpwjx08oC3YywyMuf17EGcYKaHR0FML79JtWu6StXg-CxVpnZPgvYPauNoU_ne0_7ISqrE6tjfIDMUGLFE6ptxdvyUNFdzlClcBT175AUJpjepLEp-UHeu--s7R";
    if(inviteThrough == 'newmessage')
    {
      if(emailData.message=="" || emailData.message==undefined)
      {
        log.info('Android implementation - EMPTY MSG');
      }
      else
      {
      var payload = {
          data: {
            title: 'Chat',
            message: username + " : "+emailData.message,
            msgcnt: emailData.allunread.toString(),
            fromuserid: emailData.fromuserid,
            touserid:emailData.touserid,
            chattype:emailData.chattype,
            roomid:emailData.roomid,
            roomunread:emailData.roomunread.toString(),
            allunread:emailData.allunread.toString(),
            timestamp:emailData.timestamp.toString(),
            members:mcount.toString()
        }
      };
      log.info("push payload for new message"+JSON.stringify(payload));
     }
    }
    else
    {
      var alertToSend;
     if(inviteThrough == "chat")
      {
          alertToSend = "Chat invite from "+emailData.invitinguser;
      }
      else{
          alertToSend = "Invite";
      }
      var payload = {
        data: {
           title : 'Chat',
           message: username + " : "+ alertToSend,
           roomid: rId,
           userid: userid,
           members: mcount.toString(),
           invitethrough: inviteThrough,
           invitecode:emailData.invitecode.toString(),
           moc:emailData.moc,
           msgcnt: emailData.allunread.toString()
         }
      };
    }
}
});
}
	catch(err)
	{
		log.error("error in pushnotify:");
		//res.status(500).json({ 'error': 'error in pushnotify'});
	}
}

getUsername = function(userid,callback){
      db.profiles.findOne({'userId':userid},function(err,profile){
      if(err)
      {
        log.error('Error in getting Profile');
        callback("");
      }
      else if(profile)
      {
        log.info('Valid profile found');
        var username = profile.username.firstname +" "+ profile.username.lastname;
        log.info("sender username"+username);
        callback(username);
      }
      else
      {
        log.info('Profile does not exist');
        callback("");
      }
    });
}
module.exports.getHash = function (mailid)
{
	var data = mailid;
	var md5Result = crypto.createHash('md5').update(data).digest("hex");
	log.info('md5 equivalent of '+data+ ' is ' +md5Result );
	return md5Result;
}

module.exports.findInArray = function(arr,obj) {
    return (arr.indexOf(obj) != -1);
}

module.exports.getAdjustedDateTime = function(numberOfDays)
{
  return new Date().adjustDate(numberOfDays);
}

if(!Date.prototype.adjustDate){
    Date.prototype.adjustDate = function(days){
        var date;

        days = days || 0;

        if(days === 0){
            date = new Date( this.getTime() );
        } else if(days > 0) {
            date = new Date( this.getTime() );

            date.setDate(date.getDate() + days);
        } else {
            date = new Date(
                this.getFullYear(),
                this.getMonth(),
                this.getDate() - Math.abs(days),
                this.getHours(),
                this.getMinutes(),
                this.getSeconds(),
                this.getMilliseconds()
            );
        }

        return date.getTime();
    };
}



module.exports.findusernameById = function(userid,callback){

  log.info(" Util-findusernameById " +userid);
  db.profiles.findOne({userId:userid},function(err,result) {
  if (err) {
      log.error("Error in findusernameById");
      callback("error");
  }else if(!result)
  {
    log.info("findusernameById userid NOT found");
    callback("invalid userid");
  }
  else
  {
    var phonenumber = "";
    var initiatoremail = "";
    // if(result != null)
    var initiatiorname = result.username.firstname;
    if(result.email.length>0)
    {
       initiatoremail = result.email[0].value;
    }
    if(result.contactnumber.length>0)
    {
       phonenumber = result.contactnumber[0].value;
    }

    var  initiatorname = result.username;
    var value = { 'initiatorname':initiatorname,
                  'initiatoremail':initiatoremail,
                  'phonenumber':phonenumber };

    log.info("Util-findusernameById :" +JSON.stringify(value));
    callback(value);
  }

});

}

module.exports.getRandomCode = function()
{
    return uid.v1();
}

findNoOfDays = function(intialtime,currenttime){
 var oneDay = 24*60*60*1000;
 return diff = Math.round(Math.abs((intialtime - currenttime)/(oneDay)));
}


function formatMessage(errorToReport) {
  return 'ALERT! It appears the server is' +
    'having issues. Exception: ' + errorToReport
};

notifyOnError = function(appError) {
  var client = twilioInterface(config.twilioAccountSid, config.twilioAuthToken);
    var messageToSend = formatMessage(appError);
    client.messages.create({
      to: config.Smsnotifytoadmin,
      from: config.twilioFromNumber,
      body: messageToSend,
  });
};

module.exports.auditlog=function(userID,eventTObeSaved)
{
  var auditLog = new db.alog({
          userId: userID,
          event: eventTObeSaved,
          timestamp: new Date().getTime()
  });
      auditLog.save(function (err, userObj) {
          if (err) {
              log.error("Audit log save error in event:"+event+"ERROR:"+err);
          } else {
              log.info('Audit log saved successfully:');
          }
  });
};

//Find whether the user is an admin
module.exports.validateForAdminUser = function(userId,roomid,callback){
  try{
  // log.info('validateForAdminUser for userID: '+userId+" and roomID: "+roomid);
  var numberOfAttendees;
  var summary;
  db.chatGroup.findOne({$and:[{'roomId':roomid.trim()},{'admins':{'$elemMatch':{'$eq':userId.trim()}}}]},function(err,group){
    if(err)
    {
      log.error("validateForAdminUser ADMIN ERROR:");
    }
    else
    {
      if(group==null)
      {
        // log.info("validateForAdminUser NOT AN ADMIN:");
        callback(false,0);
      }
      else
      {
        // log.info("validateForAdminUser valid ADMIN :"+group.roomId);
        numberOfAttendees = group.attendees.length
        summary = group.message;
        callback(true,group);
      }
    }
  });
  }
  catch(err)
  {
    log.error("error in validateForAdminUser:"+err);
  }
}

//Get purpose of the created room by input as roomId
module.exports.getPurposeFromRoomId = function(roomid,callback){
  try{
    db.chatGroup.findOne({'roomId':roomid},function(err,result) {
      var resultObtained;
      if (err) {
        log.info(err);
      }else{
        if(!result)
        {
          log.info("NO purpose found");
          return callback("");
        }
        else
        {
          resultObtained = result;
          return callback(resultObtained);
        }
      }
    });
  }
  catch(err)
  {
    log.error("error in util getPurposeFromRoomId:"+err);
  }
}
getFormattedEmail = function(unformattedEmail,callback){
  if(validator.isEmail(unformattedEmail) == true)
  {
    var fomattedEmail = unformattedEmail.replace(/\./g,'');
    return callback(fomattedEmail);
  }
  else
  {
    return callback(unformattedEmail);
  }
}
module.exports.getFormattedEmail=getFormattedEmail;
